function [FP] = preprocess(I)

% clc
% clear all
% close all
% 
% filename = 'fingerprint2.jpg';
% I = imread(filename);

%convert image from rgb to gray scale
Igray = rgb2gray(I);

%convert grayscale image to binary image
Ibw = Igray < 128;

Ibw( :, all(~Ibw,1) ) = [];      %delete all columns that contain 0's (black space)
Ibw( all(~Ibw,2), : ) = [];      %delete all rows that contain 0's (black space)
%figure('Name','Binary'), imshow(Ibw)


%minimizes staircasing effect
myfilter = fspecial('gaussian',[4 4], .5);
Ibw = imfilter(Ibw, myfilter);

%figure('Name','Filter'), imshow(Ibw)

%Ibw = bwmorph(Ibw,'erode');
%figure('Name','erode'), imshow(Ibw)


%thin lines in binary image until they have a thickness of one pixel
Ibw = bwmorph(Ibw, 'thin', inf);

%figure('Name','Thin'), imshow(Ibw)

%Ibw = bwmorph(Ibw,'spur', 3);
%figure('Name','Spur'), imshow(Ibw)
%Ibw = imresize(Ibw, [3 7]);
%invert matrix
FP  = ~Ibw;
%imshow(FP)






